﻿using System;
using System.Linq;
using System.ServiceModel.DomainServices.Client;
using System.Windows;
using System.Windows.Controls;

using SL5_BOARD.Views;
using SL5_BOARD.ViewModels;
using System.ComponentModel.Composition;

using System.Collections.ObjectModel;
using System.Windows.Data;

namespace SL5_BOARD
{
    public partial class MainPage : UserControl
    {
        //메인 페이지 뷰모델 임포트
        [Import(typeof(MainPageViewModel))]
        public MainPageViewModel MainPageVM {get; set;}

        /// <summary>
        /// 가상 프로퍼티 보드메인뷰
        /// </summary>
        public virtual BoardMainView VBoardMainView { get; set; }

        /// <summary>
        /// 가상 프로퍼티 보드리스트뷰
        /// </summary>
        public virtual BoardListView VBoardListView { get; set; }

        /// <summary>
        /// 가상 프로퍼티 회원관리뷰
        /// </summary>
        public virtual MstMemberView VMstMemberView { get; set; }

        public MainPage()
        {
            InitializeComponent();

            //임포트 초기화 : 이명령은 뷰단에서 한번 실행되면, 그 하위 컴포넌트 들도 차례대로 인스턴스화 된다.
            CompositionInitializer.SatisfyImports(this);

            //메인페이지 뷰모델을 LayoutRoot의 DataContext에 바인딩
            LayoutRoot.DataContext = MainPageVM;

            MainPageVM.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(MainPageVM_PropertyChanged);

            VBoardMainView = new BoardMainView();
            VBoardListView = new BoardListView();
            VMstMemberView = new MstMemberView();
        }

        /// <summary>
        /// 메인페이지뷰모델 프로퍼티 체인지 이벤트
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void MainPageVM_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            switch (e.PropertyName)
            {
                case "CurrentViewName":
                    switch (MainPageVM.CurrentViewName)
                    { 
                        case "BoardMainView":
                            MainPageVM.CurrentView = VBoardMainView;
                            break;
                        case "BoardListView":
                            MainPageVM.CurrentView = VBoardListView;
                            break;
                        case "MstMemberView":
                            MainPageVM.CurrentView = VMstMemberView;
                            break;
                    }
                    break;
                default:
                    break;
            }
       }

    }
}
