﻿using System.ComponentModel;
using System.ComponentModel.Composition;
using System.Windows.Input;
using Microsoft.Expression.Interactivity.Core;
using SL5_BOARD.Models;
using SL5_BOARD.Web.Model;

namespace SL5_BOARD.ViewModels
{
    [Export(typeof(BoardMainViewModel))]
    public class BoardMainViewModel : INotifyPropertyChanged
    {
        #region PropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(PropertyName));
            }
        }
        #endregion

        [Import(typeof(BoardMain))]
        public BoardMain BoardMainData { get; set; }

        public BoardMainViewModel()
        { 
            //BoardMainData.BoardTypeCol
        }

        ICommand selectCommand;
        public ICommand SelectCommand
        {
            get
            {
                if (selectCommand == null)
                {
                    selectCommand = new ActionCommand(() =>
                    {
                        BoardMainData.Getting();
                    });
                }
                return selectCommand;
            }
        }
        public void Select()
        {
            BoardMainData.Getting();
        }

        ICommand addCommand;
        public ICommand AddCommand
        {
            get
            {
                if (addCommand == null)
                {
                    addCommand = new ActionCommand(() =>
                    {
                        BOARD_MAIN bm = new BOARD_MAIN();
                        bm.BOARD_NAME = "신규 게시판의 명칭을 입력하세요";
                        bm.BOARD_DESC = "신규 게시판의 설명을 입력하세요";
                        BoardMainData.Adding(bm);
                    });
                }
                return addCommand;
            }
        }

        ICommand removeCommand;
        public ICommand RemoveCommand
        {
            get
            {
                if (removeCommand == null)
                {
                    removeCommand = new ActionCommand(p =>
                    {
                        if (p != null)
                        {
                            BOARD_MAIN bm = p as BOARD_MAIN;
                            BoardMainData.Removing(bm);
                        }
                    });
                }
                return removeCommand;
            }
        }

        ICommand saveCommand;
        public ICommand SaveCommand
        {
            get
            {
                if (saveCommand == null)
                {
                    saveCommand = new ActionCommand(() =>
                    {
                        BoardMainData.Saving();
                    });
                }
                return saveCommand;
            }
        }

        ICommand cancelCommand;
        public ICommand CancelCommand
        {
            get
            {
                if (cancelCommand == null)
                {
                    cancelCommand = new ActionCommand(() =>
                    {
                        BoardMainData.Canceling();
                    });
                }
                return cancelCommand;
            }
        }
        
        ICommand selectChanged;
        public ICommand SelectChangedCommand
        {
            get
            {
                if (selectChanged == null)
                {
                    selectChanged = new ActionCommand(para => SelectChangedOperation(para));
                }
                return selectChanged;
            }
        }
        private void SelectChangedOperation(object para)
        { 
            BoardMainData.CurrentData = para as BOARD_MAIN;
        }

        ICommand changeStateCommand;
        public ICommand ChangeStateCommand
        {
            get
            {
                if (changeStateCommand == null)
                {
                    changeStateCommand = new ActionCommand(para => ChangeStateOperation(para));
                }
                return changeStateCommand;
            }
        }
        private void ChangeStateOperation(object para)
        {
            BoardMainData.BoardStateText = para as string;
        }

    }
}
