﻿using System.ComponentModel;
using System.ComponentModel.Composition;
using System.Windows.Input;
using Microsoft.Expression.Interactivity.Core;
using SL5_BOARD.Models;
using SL5_BOARD.Web.Model;
using System.Windows.Controls;

namespace SL5_BOARD.ViewModels
{
    [Export(typeof(MstMemberViewModel))]
    public class MstMemberViewModel : INotifyPropertyChanged
    {
        #region PropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(PropertyName));
            }
        }
        #endregion

        //회원 마스터 모델 임포트
        [Import(typeof(MstMember))]
        public MstMember MstMemberData { get; set; }

        //생성자
        public MstMemberViewModel()
        { 
        }

        //회원 전체 조회
        ICommand selectCommand;
        public ICommand SelectCommand
        {
            get
            {
                if (selectCommand == null)
                {
                    selectCommand = new ActionCommand(() =>
                    {
                        MstMemberData.Getting();
                    });
                }
                return selectCommand;
            }
        }
        public void Select()
        {
            MstMemberData.Getting();
        }

        //조건을 가지는 조회 커맨드
        ICommand selectConditionCommand;
        public ICommand SelectConditionCommand
        {
            get
            {
                if (selectConditionCommand == null)
                {
                    selectConditionCommand = new ActionCommand(condition =>
                    {
                        //조건을 가지는 회원 조회 함수 실행
                        MstMemberData.Getting(condition as string);
                    });
                }
                return selectConditionCommand;
            }
        }


        //회원 추가
        ICommand addCommand;
        public ICommand AddCommand
        {
            get
            {
                if (addCommand == null)
                {
                    addCommand = new ActionCommand(() =>
                    {
                        MST_MEMBER obj = new MST_MEMBER();
                        MstMemberData.Adding(obj);
                    });
                }
                return addCommand;
            }
        }

        //회원 삭제
        ICommand removeCommand;
        public ICommand RemoveCommand
        {
            get
            {
                if (removeCommand == null)
                {
                    removeCommand = new ActionCommand(p =>
                    {
                        if (p != null)
                        {
                            MST_MEMBER obj = p as MST_MEMBER;
                            MstMemberData.Removing(obj);
                        }
                    });
                }
                return removeCommand;
            }
        }

        //저장
        ICommand saveCommand;
        public ICommand SaveCommand
        {
            get
            {
                if (saveCommand == null)
                {
                    saveCommand = new ActionCommand(() =>
                    {
                        MstMemberData.Saving();
                    });
                }
                return saveCommand;
            }
        }

        //취소
        ICommand cancelCommand;
        public ICommand CancelCommand
        {
            get
            {
                if (cancelCommand == null)
                {
                    cancelCommand = new ActionCommand(() =>
                    {
                        MstMemberData.Canceling();
                    });
                }
                return cancelCommand;
            }
        }

        //회원 변경
        ICommand selectChanged;
        public ICommand SelectChangedCommand
        {
            get
            {
                if (selectChanged == null)
                {
                    selectChanged = new ActionCommand(para => SelectChangedOperation(para));
                }
                return selectChanged;
            }
        }
        private void SelectChangedOperation(object para)
        {
            MstMemberData.CurrentData = para as MST_MEMBER;
        }

        //로그인
        ICommand loginCommand;
        public ICommand LoginCommand
        {
            get
            {
                if (loginCommand == null)
                {
                    loginCommand = new ActionCommand(pnl => LoginOperation(pnl));
                }
                return loginCommand;
            }
        }
        private void LoginOperation(object pnl)
        {
            StackPanel sp = pnl as StackPanel;
            string email;
            string password;

            MstMemberData.Getting();
        }

        //이메일 주소 확인

    }
}
